% Copyright (C) Paweł Płazieński 2009
%
% This program is free software; you can redistribute it and/or modify it
% under the terms of the GNU General Public License as published by the
% Free Software Foundation; either version 2, or (at your option) any
% later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

:- consult('read-tools.pl').

add :-
	write('Name (simple property)'),
	ask_simple(Property),
 	write('Backward dependancies list (full properties list)'),
	ask_list(DependantBack),
 	write('Forward dependancies (full properties list)'),
	ask_list(DependantForw),
	add_property(Property,DependantBack,DependantForw),
	write('Success'), nl, !.

depend :-
	write('From (full property)'),
	ask_property(From),
 	write('To (full property)'),
	ask_property(To),
	add_dependancy(From,To),
	write('Success'), nl, !.

finalize :-
	write('Old (simple property)'),
	ask_simple(OldProperty),
	write('New (full property)'),
	ask_property(NewProperty),
	finalize(OldProperty,NewProperty),
	write('Success'), nl, !.

split :-
	write('Old (full property)'),
	ask_property(OldProperty),
	write('New (full property list)'),
	ask_list(NewPropertyList),
	split(OldProperty,NewPropertyList),
	write('Success'), nl, !.

ask_simple(Property) :-
	get_simple_properties(Props),
	properties_to_strings(Props,PropStrings),
	get_line(Text,PropStrings),
	not(empty_line(Text)),
	propertize([Text],Property).

ask_property(Property) :-
	get_properties(Props),
	properties_to_strings(Props,PropStrings),
	get_line(Text,PropStrings),
	not(empty_line(Text)),
	string_list(Text,List,","),
	propertize(List,Property).

ask_list(List) :-
	ask_list(List,[]).

ask_list(List,Got) :-
	get_properties(Props),
	properties_to_strings(Props,PropStrings),
 	get_line(Text,PropStrings),
 	(  empty_line(Text),
		List = Got
	;  not(empty_line(Text)),
		string_list(Text,Current,","),
		propertize(Current,Property),
		union(Got,[Property],G),
		ask_list(List,G)
	).


